config/routes.rb
require 'sidekiq/web'
require 'sidekiq/cron/web'
require 'sidekiq-status/web'

Rails.application.routes.draw do # rubocop:todo Metrics/BlockLength

  devise_for :users, controllers: {
    registrations: 'users/registrations'
  }

  root 'home#index'
  get '/about', to: 'home#about', as: 'about'
  get '/terms', to: 'home#licence', as: 'terms'
  get '/stats', to: 'home#stats', as: 'stats'
  get '/profile', to: 'profile#index', as: 'profile'

  namespace 'api' do
    namespace 'v1' do
      get '/', to: 'home#index'
      get '/me', to: 'users#me'

      resources :kingdoms, only: %i[index show]
      resources :subkingdoms, only: %i[index show]
      resources :division_orders, only: %i[index show]
      resources :division_classes, only: %i[index show]
      resources :divisions, only: %i[index show]
      resources :families, only: %i[index show] do
        resources :genus, only: %i[index show]
      end
      resources :genus, only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end

      resources :plants, only: %i[index show] do
        resources :species, only: %i[index show]
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :species, only: %i[index show] do
        resources :record_corrections, only: %i[index], path: 'corrections'
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :record_corrections, path: 'corrections', only: %i[index show] do
        post '/:record_type/:record_id', to: 'record_corrections#create', on: :collection
        get :mine, to: 'record_corrections#index', on: :collection, mine: true
      end

      resources :zones, path: 'distributions', only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end
    end

    namespace 'auth' do
      post '/claim', to: 'auth#claim'
    end

    match '*all', controller: 'api', action: 'cors_preflight_check', via: [:options]
  end

  namespace 'explore' do
    get '/', to: 'species#index'
    get '/data', to: 'data#index'
    resources :species, only: %i[index show] do
      resources :record_corrections, only: %i[index], path: 'corrections'
    end
    resources :genus, only: %i[index show] do
    end
    resources :record_corrections, path: 'corrections', only: %i[index show] do

    end
  end

  namespace 'management' do
    authenticate :user, ->(user) { user.admin? } do
      mount PgHero::Engine, at: 'pghero'
      mount Sidekiq::Web => '/sidekiq'
    end

    get '/', to: 'plants#index'

    resources :users
    resources :user_queries do
      get :stats, on: :collection
    end
    resources :subkingdoms
    resources :species_proposals
    resources :species_images do
      get :chaos, on: :collection
    end
    resources :record_corrections do
      patch :accept, on: :member
      patch :reject, on: :member
    end

    resources :species do
      patch :refresh, on: :member
    end

    resources :sessions
    resources :plants
    resources :major_groups
    resources :kingdoms
    resources :genuses
    resources :foreign_sources_plants
    resources :foreign_sources
    resources :families
    resources :divisions
    resources :division_orders
    resources :division_classes
  end

end

app/controllers/api/v1/home_controller.rb
class Api::V1::HomeController < ApplicationController

  def index
    # puts request.user_agent
    @plants_count = Rails.cache.fetch('home/plants_count') { Plant.count }
    @detailled_plants_count = Rails.cache.fetch("home/detailled_plants_count-#{@plants_count}") { Species.where.not(foliage_color: nil).count }

    count_per_type = Rails.cache.fetch("home/count_per_type-#{@plants_count}") { Species.group(:rank).count }
    @per_species_plants_count = Rails.cache.fetch("home/per_species_plants_count-#{@plants_count}") do
      {
        'Species' => count_per_type['species'],
        'Varieties' => count_per_type['var'],
        'Hybrids' => count_per_type['hybrid'],
        'Sub-species' => count_per_type['ssp'],
        'Forms' => count_per_type['form'],
        'Cultivars' => count_per_type['cultivar']
      }
    end

    @synonyms_count = Rails.cache.fetch("home/synonyms_count-#{@plants_count}") { Synonym.count }

    render json: {
      plants_count: @plants_count,
      detailled_plants_count: @detailled_plants_count
    }
  end

end

app/controllers/home_controller.rb
class HomeController < ApplicationController

  def index
    @page_title       = 'The plants API'
    @page_description = 'Trefle is a botanical API and data source.'
    @page_keywords    = 'API, Botanical, Plants, Species, Data'

    @plants_count = Rails.cache.fetch('home/plants_count') { Plant.count }
    @detailled_plants_count = Rails.cache.fetch("home/detailled_plants_count-#{@plants_count}") { Species.where.not(foliage_color: nil).count }

    count_per_type = Rails.cache.fetch("home/count_per_type-#{@plants_count}") { Species.group(:rank).count }
    @per_species_plants_count = Rails.cache.fetch("home/per_species_plants_count-#{@plants_count}") do
      {
        'Species' => count_per_type['species'],
        'Varieties' => count_per_type['var'],
        'Hybrids' => count_per_type['hybrid'],
        'Sub-species' => count_per_type['ssp'],
        'Forms' => count_per_type['form'],
        'Cultivars' => count_per_type['cultivar']
      }
    end

    @synonyms_count = Rails.cache.fetch("home/synonyms_count-#{@plants_count}") { Synonym.count }
    @jwt = ::Auth::JsonWebToken.new(
      user: User.find_by(email: 'guest@trefle.io'),
      origin: ENV['API_HOST'],
      expire: 10.minutes
      # ip: request.headers['X-Forwarded-For']
    )
  end

  def about
    @page_title       = 'About'
    @page_description = 'Trefle is a botanical API and data source.'
    @page_keywords    = 'API, Botanical, Plants, Species, Data'
  end

  def stats; end
end

app/views/home/about.html.erb
<div class="about-page home-page container is-fluid">

  <div class="columns">
    <div class="column is-2"></div>
    <div class="column is-10">
      <section class="hero">
        <div class="hero-body">
          <div class="container">
            <h1 class="title is-1">
              <i class="fad has-text-primary fa-seedling"></i>

              About
            </h1>
            <h2 class="subtitle">
              General informations, privacy and contacts.
            </h2>
          </div>
        </div>
      </section>
    </div>
  </div>

  <div class="columns">
    <div class="column is-2">
      <br>
      <br>
      <aside class="menu">
        <ul class="menu-list">
          <li><a href="#sources">Data sources</a></li>
          <li><a href="#privacy">Privacy</a></li>
          <li><a href="#pricing">Pricing</a></li>
          <li><a href="#beta-disclaimer">Beta stage</a></li>
          <li><a href="#contact">Contact</a></li>
        </ul>
      </aside>
    </div>

    <div class="column is-10">

      <section class="section logo-section" id="about">
        <h4 class="title is-4">
          We deliver all plants informations under an accessible API.
        </h4>
      </section>

      <section class="section content logo-section" id="sources">
        <p class="has-text-centered has-text-grey">Our data is gathered with love from</p>
        <br>
        <div class="has-text-centered">
          <img style="display: inline-block; max-height: 80px; max-width: 100px; padding: 10px; margin: auto" src="<%= asset_pack_path("media/packs/images/medias/usda.svg") %>" alt="">
          <img style="display: inline-block; max-height: 80px; max-width: 100px; padding: 10px; margin: auto" src="<%= asset_pack_path("media/packs/images/medias/tela-botanica.png") %>" alt="">
          <img style="display: inline-block; max-height: 80px; max-width: 100px; padding: 10px; margin: auto" class="spadded" src="<%= asset_pack_path("media/packs/images/medias/tropicos.gif") %>" alt="">
          <img style="display: inline-block; max-height: 80px; max-width: 100px; padding: 10px; margin: auto" src="<%= asset_pack_path("media/packs/images/medias/ipni.png") %>" alt="">
          <img style="display: inline-block; max-height: 80px; max-width: 100px; padding: 10px; margin: auto" class="all-spadded" src="<%= asset_pack_path("media/packs/images/medias/kew.svg") %>" alt="">
          <img style="display: inline-block; max-height: 80px; max-width: 100px; padding: 10px; margin: auto" src="<%= asset_pack_path("media/packs/images/medias/wikimedia.png") %>" alt="">
          <img style="display: inline-block; max-height: 80px; max-width: 100px; padding: 10px; margin: auto" src="<%= asset_pack_path("media/packs/images/medias/muhitnat.png") %>" alt="">  
        </div>
        <p class="has-text-centered has-text-grey">& manually from people all around the world</p>
      </section>

      <!-- <hr> -->
      <section class="section content" id="privacy">
        <h1 class="title is-4 ">
          <i class="fad fa-user-secret has-text-success"></i> (very short) privacy policy
        </h1>
        <p>Trefle.io take your privacy seriously and will take all measures to protect your personal information.</p>
        <p>Any personal information received will only be used to fulfill your order, and may be used for anonymized internal analytical purposes.</p>
        <p>We will not sell or redistribute your information to anyone.</p>
      </section>

      <section class="section content" id="pricing">
        <h1 class="title is-4 ">
          <i class="fad fa-money-bill-wave has-text-success"></i> Pricing
        </h1>
        <p><b>Trefle is currently in beta and still learning how it can be most helpful.</b></p>
        <p>While in beta, <b>Trefle will be free for all</b>. Additionally, Trefle will always be free for open-source individuals, organizations and non-profit communities.</p>
      </section>


      <section class="section content" id="beta-disclaimer">
        <h1 class="title is-4 ">
          <i class="fad fa-flask-potion has-text-success"></i>
          Beta disclaimer
        </h1>
        <p>Trefle is actually in beta stage, which implies that bugs and issues may still remain undiscovered until this phase of testing is complete.</p>
        <p>The beta stage also means that the data may be corrupted, is not 100% validated or complete, and is subject to change.</p>
        <p>Finally, services may have downtime and the API schemas and calls are subject to change.</p>
      </section>
      <hr>
      <section class="section content" id="contact">
        <h1 class="title is-4 ">
          <i class="fad fa-mailbox has-text-success"></i>

          Contact us
        </h1>
        <p>If you have questions, advices, partnerships or if you just want to say hello, please contact us, we'll be our pleasure to reply!</p>

      </section>
      <section class="section content" id="contact">
        <div class="columns">
          <div class="column is-4">
            <a href="mailto:hello@trefle.io">
              <h2 class="title is-5 has-text-centered">Send us a mail</h2>
              <p class="has-text-centered">hello@trefle.io</p>
            </a>
          </div>
          <div class="column is-4">
            <a title="Join us on Discord" href="https://discord.gg/fuamwgk" target="_blank">
              <h2 class="title is-5 has-text-centered">Join us on Discord</h2>
              <p class="has-text-centered">
                <span class="icon" style="color: #7289da;">
                  <i class="fab fa-3x fa-lg fa-discord"></i>
                </span>
              </p>
            </a>
          </div>
          <div class="column is-4">
            <a title="Follow us on Twitter" href="https://twitter.com/trefle_api" target="_blank">
              <h2 class="title is-5 has-text-centered">Follow us on Twitter</h2>
              <p class="has-text-centered">
                <span class="icon" style="color: #55acee;">
                  <i class="fab fa-3x fa-lg fa-twitter"></i>
                </span>
              </p>
            </a>
          </div>
        </div>
      </section>

    </div>
  </div>

app/views/home/index.html.erb
<% cache [:home, :index, TrefleAdmin::Application::VERSION, current_user.nil?] do %>
  <div class="home-page container">
    <section class="hero">
      <div class="hero-body">
        <div class="container">
          <div class="columns">
            <div class="column is-10 is-offset-1">
              <h1 class="main-title title is-1">
                <%= image_tag(asset_pack_path("media/packs/images/logo.svg"), alt: "logo") %>
                <p class="title-vertical">Trefle</p>
              </h1>
              <h2 class="subtitle">
                A global plants API
              </h2>
            </div>
          </div>
        </div>
      </div>
    </section>

    <section class="section">
      <div class="container">
        <div class="columns">
          <div class="column is-10 is-offset-1">
            <h2 class="subtitle">
              <p>We are an open, freely accessible botanical data source and REST API.</p>
            </h2>
          </div>
        </div>
        <div class="columns">
          <div class="column is-10 is-offset-1">
            <div class="buttons">
              <a href="https://docs.trefle.io" class="button is-info is-outlined">Browse the docs</a>
              <% if current_user %>
              <a href="<%= profile_path %>" class="button is-primary">My account</a>
              <% else %>
              <a href="<%= new_user_registration_path %>" class="button is-primary">Get started</a>
              <% end %>
            </div>
          </div>
        </div>
      </div>
    </section>

    <section class="section is-hidden-mobile">
      <div class="container">
        <div id="code-sandbox">

        </div>
      </div>
    </section>
    <section class="section">
      <div class="container">
        <div class="columns">
          <div class="column is-1">
            <h1 class="title has-text-centered">
              <i class="fad has-text-primary fa-magic"></i>
            </h1>
          </div>
          <div class="column is-10">
            <h1 class="title">
              Explore <%= number_to_human(@plants_count + @synonyms_count, precision: 1).downcase %> indexed plants!
            </h1>
            <h2 class=" subtitle">
              including <%= number_to_human(@detailled_plants_count, precision: 1).downcase %> with detailed data, and <%= number_to_human(@synonyms_count, precision: 1).downcase %> synonyms!
            </h2>
          </div>
        </div>
        <div class="columns">
          <div class="column is-1">
          </div>
          <div class="column is-3">
            <div id="persp-chart"></div>
          </div>
          <div class="column is-7">
            <div id="persp-chart-legend"></div>
          </div>
        </div>
      </div>
    </section>
    <hr />
    <section class="section">
      <div class="container">
        <div class="columns">
          <div class="column is-10 is-offset-1">
            <h1 class="title">
              A complete plants API for...
            </h1>
            <br />
          </div>
        </div>
        <div class="columns">
          <div class="column is-1">
            <h1 class="title is-4 has-text-centered">
              <i class="fad has-text-primary fa-robot"></i>
            </h1>
          </div>
          <div class="column is-5">
            <h1 class="title is-4">
              Robots
            </h1>
            <p>
              <mark>Build the next gardening apps and farming robots</mark> by getting high-level informations, such as minimum temperature, root minimum depth or fertility requirement.
            </p>
          </div>
          <div class="column is-1">
            <h1 class="title is-4 has-text-centered">
              <i class="fad has-text-primary fa-search"></i>
            </h1>
          </div>
          <div class="column is-5">
            <h1 class="title is-4">
              Researchers
            </h1>
            <p>
              <mark>Search over (almost) all the plants of the world</mark> over multiple criterias, and get up-to-date informations, taxonomical references and more
            </p>
          </div>
        </div>
        <div class="columns">
          <div class="column is-1">
            <h1 class="title is-4 has-text-centered">
              <i class="fad has-text-primary fa-seedling"></i>
            </h1>
          </div>
          <div class="column is-5">
            <h1 class="title is-4">
              Gardeners & nature lovers
            </h1>
            <p>
              Get detailed informations about how, when and where to grow your plants.
            </p>
          </div>
          <div class="column is-1">
            <h1 class="title is-4 has-text-centered">
              <i class="fad has-text-primary fa-book-heart"></i>
            </h1>
          </div>
          <div class="column is-5">
            <h1 class="title is-4">
              Students
            </h1>
            <p>
              Get in touch! We try to support educational projects as much as we can!
            </p>
          </div>
        </div>
      </div>
    </section>
    <hr />
    <section class="section">
      <div class="columns">
        <div class="column is-10 is-offset-1">
          <article class="message is-primary">
            <div class="message-header">
              <p>Trefle is out of alpha !</p>
            </div>
            <div class="message-body">
              We just released the 1.6.0. <a href="https://docs.trefle.io/blog/1-6-0-released">Check the release notes !</a>
            </div>
          </article>
        </div>
      </div>
  </div>
<% end %>

<script>
  var persp = <%= @per_species_plants_count.to_json.html_safe %> ;
  var temp_token = "<%= @jwt.token %>";
</script>

<%= javascript_pack_tag 'home/codesandbox' %>
<%= javascript_pack_tag 'home/home' %>

app/views/home/licence.erb
<div class="licence-page home-page container">

      <section class="hero">
        <div class="hero-body">
          <div class="container">
            <h1 class="title is-1">
              <i class="fad has-text-primary fa-book"></i>

              Terms of use
            </h1>
            <h2 class="subtitle">
              How to use, cite and provide Trefle data.
            </h2>
          </div>
        </div>
      </section>
      <section class="section content" id="privacy">
        <p><b>The Trefle API aims to increase awareness and understanding of living plants by gathering, generating and sharing knowledge in an open, freely accessible and trusted digital resource. By using Trefle you accept and agree to abide by the following terms and conditions.</b></p>
      </section>


    <!-- <hr> -->
    <section class="section content" id="tldr">
      <h1 class="title is-4 ">
        <i class="fad fa-shipping-fast has-text-success"></i> TL;DR
      </h1>
      <ul>
        <li>The Trefle APIs are freely available for anyone to use.</li>
        <li>When sharing or reusing Trefle data, you must credit Trefle and the other data sources (if any) present in the JSON response of the data you are using.</li>
        <li>You must comply with the licenses associated with the Materials you acquire from Trefle, and agree to pass on all license terms and attributions associated with the objects as required by the licenses associated with those Materials.</li>
      </ul>
    </section>

    <!-- <hr> -->
    <section class="section content" id="community">
      <h1 class="title is-4 ">
        <i class="fad fa-user has-text-success"></i> Community
      </h1>
      <b>Together we can make Trefle the best, most comprehensive source for plants information.</b>
      <p>Anyone who registers for a user account is an Trefle Member. An Trefle Content Partner is an individual or organization that shares content for redisplay by Trefle. Anyone 13 years or older can register to become an Trefle member in order to take advantage of opportunities to download data from Trefle and use other interactive capabilities of the site. To register, visit the registration page .</p>
    </section>

    <section class="section content" id="usages">
      <h1 class="title is-4 ">
        <i class="fad fa-cog has-text-success"></i> Usage
      </h1>
      <p>The Trefle APIs are freely available for anyone to use. Currently, you must register with Trefle to indicate your desire to use them, which will allow us to better support your use of the API. </p>
      <p>If you develop a technology as a result of your use of Trefle and the Materials on Trefle, we encourage you to provide us with information about such technology. Sharing your success with us will help foster the Trefle community by providing examples of success. We may choose to feature your story or highlight your technology or product on the website.</p>
      <p>You also agree to comply with the licenses associated with the Materials you acquire from Trefle. You also agree to pass on all license terms and attributions associated with the objects as required by the licenses associated with those Materials.</p>
      <p>If you wish to acquire all or major portions of the Materials from any individual content provider, you are required to contact that content provider directly.</p>
      <p>We reserve the right to monitor usage of our APIs and to discontinue access to Trefle by users of the APIs who are determined to be in violation of this Agreement. If you have registered with us, we will make an effort to notify you of any potential violations. In addition to monitoring, we may maintain records of API use and information about the requestor.</p>
    </section>

    <section class="section content" id="credits">
      <h1 class="title is-4 ">
        <i class="fad fa-file-certificate has-text-success"></i> Credit
      </h1>
      <p>Data accessed through the Trefle API network is free for all—but not free of obligations. You must credit Trefle, as well as the other sources (which are included in the API response). Good citation practices ensure scientific transparency and reproducibility by guiding other researchers to the original sources of information. They also reward data-publishing institutions and individuals by reinforcing the value of sharing open data and demonstrating its impact to their stakeholders and funders.</p>
      <p>Trefle Content is provided by the community, and can be lacking of credits or be in a copyright violation. If you have any complaints or objections to content posted on Trefle because it was not properly credited or it was posted without permission and you are the copyright or trademark owner, please contact Trefle at hello@trefle.io and provide your contact information, a working link to the relevant content on Trefle, a statement that you are the copyright owner or the owner's agent, and links or other evidence supporting your claim of ownership.</p>
      <p>The Content is provided “as is” without a warranty of any kind, either expressed or implied, including but not limited to the implied warranties of merchantability, fitness for a particular use, and/or non-infringement. Trefle shall not be responsible or liable for any damage that may occur due to your use of Trefle or downloading any Content from Trefle. If you need specific advice (for example, medical or veterinarian) please seek a professional who is licensed or knowledgeable in the appropriate field.</p>
      <p>Certain names, titles, trademarks, service marks, and logos that appear on Trefle are registered or common law (unregistered) marks owned by Trefle members, Trefle content providers, or third parties. With the exception of fair use, you may not use such trademarks without the owner’s prior written permission. Nothing on Trefle shall be construed as granting any license to use any trademark displayed on Trefle without the express written permission of the owner of the trademark.</p>
    </section>

    <section class="section content" id="other">
      <p>Trefle reserves the right to change these Terms of Use from time to time without notice; changes shall be effective upon posting. Please check back regularly for updates. Failure of Trefle to enforce any of these terms shall not constitute a waiver of such terms.</p>
      <p><i>Last modified on Wed, 15 Jul 2020</i></p>
    </section>

    <hr>
    <section class="section content" id="contact">
      <h1 class="title is-4 ">
        <i class="fad fa-mailbox has-text-success"></i>

        Contact us
      </h1>
      <p>If you have questions, advices, partnerships or if you just want to say hello, please contact us, we'll be our pleasure to reply!</p>

    </section>
    <section class="section content" id="contact">
      <div class="columns">
        <div class="column is-4">
          <a href="mailto:hello@trefle.io">
            <h2 class="title is-5 has-text-centered">Send us a mail</h2>
            <p class="has-text-centered">hello@trefle.io</p>
          </a>
        </div>
        <div class="column is-4">
          <a title="Join us on Discord" href="https://discord.gg/fuamwgk" target="_blank">
            <h2 class="title is-5 has-text-centered">Join us on Discord</h2>
            <p class="has-text-centered">
              <span class="icon" style="color: #7289da;">
                <i class="fab fa-3x fa-lg fa-discord"></i>
              </span>
            </p>
          </a>
        </div>
        <div class="column is-4">
          <a title="Follow us on Twitter" href="https://twitter.com/trefle_api" target="_blank">
            <h2 class="title is-5 has-text-centered">Follow us on Twitter</h2>
            <p class="has-text-centered">
              <span class="icon" style="color: #55acee;">
                <i class="fab fa-3x fa-lg fa-twitter"></i>
              </span>
            </p>
          </a>
        </div>
      </div>
    </section>

</div>